/**
 * Copyright (C) 2011 Agrosense <info@cloudfarming.nl>
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain a
 * copy of the License at
 *
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package nl.cloudfarming.client.isobus.project;

import java.io.IOException;
import org.netbeans.api.project.Project;
import org.netbeans.spi.project.ProjectFactory;
import org.netbeans.spi.project.ProjectState;
import org.openide.filesystems.FileObject;
import org.openide.util.lookup.ServiceProvider;

/**
 *
 * 
 * 
 * @author Gerben Feenstra
 */
@ServiceProvider(service=ProjectFactory.class)
public class IsobusProjectFactory implements ProjectFactory{

    public static final String TASK_FILES = "taskfiles";
    
    @Override
    public boolean isProject(FileObject selectedDirectory) {   
        boolean containsTaskdata = selectedDirectory.getFileObject(TASK_FILES) != null;
        return containsTaskdata;
    }
            
    @Override
    public Project loadProject(FileObject projectDirectory, ProjectState state) throws IOException {
        return isProject(projectDirectory) ? new IsobusProject(projectDirectory, state) : null;
    }

    @Override
    public void saveProject(Project project) throws IOException, ClassCastException {
//        FileObject projectRoot = project.getProjectDirectory();
//        if (projectRoot.getFileObject(PROJECT_DIR) == null) {
//            throw new IOException("Project dir " + projectRoot.getPath() +
//                    " deleted," +
//                    " cannot save project");
//        }
//        //Force creation of the texts dir if it was deleted:
//        ((DemoProject) project).getTextFolder(true);
        throw new UnsupportedOperationException("Saving Isobus project is not supported yet.");
    }
    
    

}
